LIBRARY IEEE;
USE IEEE.std_logic_1164.all;

LIBRARY atml_vtl;
USE atml_vtl.VCOMPONENTS.all;

ENTITY Johnson IS
    PORT (
      CLKi : in std_logic;
      RASei : in std_logic;
      SRn : in std_logic;
      John_D : inout std_logic;
      RAS_ : out std_logic;
      RASe1 : out std_logic;
      RASe0 : out std_logic;
      Qc6 : out std_logic;
      Qc5 : out std_logic;
      Qc4 : out std_logic;
      Qc3 : out std_logic;
      Qc2 : out std_logic;
      Qc1 : out std_logic;
      Qc0 : out std_logic);
END Johnson;

ARCHITECTURE P1508C84  OF Johnson IS

SIGNAL gnd : std_logic;
SIGNAL vcc : std_logic;
SIGNAL Qc5_Q, Qc5_REG, XXL_35, Qc6_REG, Qc4_Q, Qc4_REG, Qc2_Q, Qc2_REG, Qc3_Q, Qc3_REG, Qc1_Q, Qc1_REG, Qc0_Q, Qc0_REG, RASe1_Q, RASe1_REG, RASe0_Q, RASe0_REG, s_0, s_1, s_2, s_3, s_4, s_5, s_6, s_7, s_8, s_9, s_10, s_11, s_12, s_13, s_14, s_15, s_16, s_17, s_18, s_19, s_20, s_21, s_22, s_23, s_24, s_25, s_26, s_27, s_28, s_29, s_30, s_31, s_32, s_33, s_34, s_35, s_36, s_37, s_38, s_39, s_40, s_41, s_42, s_43, s_44, s_45, s_46, s_47, s_48, s_49, s_50, s_51, s_52, s_53, s_54, s_55, s_56, s_57, s_58 : std_logic;

BEGIN
gnd <= '0';
vcc <= '1';
John_D <= s_30;
TRI_7: TRI
    PORT MAP (Q => Qc5, A => Qc5_Q, EN => vcc);
DFFEARS_5: DFFEARS
    PORT MAP (Q => Qc5_Q, D => Qc5_REG, CLK => s_0, AR => gnd, AS => gnd, CE => vcc);
BUF_6: BUF
    PORT MAP (Q => s_0, A => CLKi);
XOR2_4: XOR2
    PORT MAP (Q => Qc5_REG, A1 => s_1, A2 => gnd);
OR1_3: OR1
    PORT MAP (Q => s_1, A1 => s_2);
AND2_2: AND2
    PORT MAP (Q => s_2, A1 => s_3, A2 => s_4);
BUF_0: BUF
    PORT MAP (Q => s_3, A => Qc4_Q);
BUF_1: BUF
    PORT MAP (Q => s_4, A => SRn);
TRI_15: TRI
    PORT MAP (Q => Qc6, A => XXL_35, EN => vcc);
DFFEARS_13: DFFEARS
    PORT MAP (Q => XXL_35, D => Qc6_REG, CLK => s_5, AR => gnd, AS => gnd, CE => vcc);
BUF_14: BUF
    PORT MAP (Q => s_5, A => CLKi);
XOR2_12: XOR2
    PORT MAP (Q => Qc6_REG, A1 => s_6, A2 => gnd);
OR1_11: OR1
    PORT MAP (Q => s_6, A1 => s_7);
AND2_10: AND2
    PORT MAP (Q => s_7, A1 => s_8, A2 => s_9);
BUF_8: BUF
    PORT MAP (Q => s_8, A => Qc5_Q);
BUF_9: BUF
    PORT MAP (Q => s_9, A => SRn);
TRI_23: TRI
    PORT MAP (Q => Qc4, A => Qc4_Q, EN => vcc);
DFFEARS_21: DFFEARS
    PORT MAP (Q => Qc4_Q, D => Qc4_REG, CLK => s_10, AR => gnd, AS => gnd, CE => vcc);
BUF_22: BUF
    PORT MAP (Q => s_10, A => CLKi);
XOR2_20: XOR2
    PORT MAP (Q => Qc4_REG, A1 => s_11, A2 => gnd);
OR1_19: OR1
    PORT MAP (Q => s_11, A1 => s_12);
AND2_18: AND2
    PORT MAP (Q => s_12, A1 => s_13, A2 => s_14);
BUF_16: BUF
    PORT MAP (Q => s_13, A => Qc3_Q);
BUF_17: BUF
    PORT MAP (Q => s_14, A => SRn);
TRI_31: TRI
    PORT MAP (Q => Qc2, A => Qc2_Q, EN => vcc);
DFFEARS_29: DFFEARS
    PORT MAP (Q => Qc2_Q, D => Qc2_REG, CLK => s_15, AR => gnd, AS => gnd, CE => vcc);
BUF_30: BUF
    PORT MAP (Q => s_15, A => CLKi);
XOR2_28: XOR2
    PORT MAP (Q => Qc2_REG, A1 => s_16, A2 => gnd);
OR1_27: OR1
    PORT MAP (Q => s_16, A1 => s_17);
AND2_26: AND2
    PORT MAP (Q => s_17, A1 => s_18, A2 => s_19);
BUF_24: BUF
    PORT MAP (Q => s_18, A => Qc1_Q);
BUF_25: BUF
    PORT MAP (Q => s_19, A => SRn);
TRI_39: TRI
    PORT MAP (Q => Qc3, A => Qc3_Q, EN => vcc);
DFFEARS_37: DFFEARS
    PORT MAP (Q => Qc3_Q, D => Qc3_REG, CLK => s_20, AR => gnd, AS => gnd, CE => vcc);
BUF_38: BUF
    PORT MAP (Q => s_20, A => CLKi);
XOR2_36: XOR2
    PORT MAP (Q => Qc3_REG, A1 => s_21, A2 => gnd);
OR1_35: OR1
    PORT MAP (Q => s_21, A1 => s_22);
AND2_34: AND2
    PORT MAP (Q => s_22, A1 => s_23, A2 => s_24);
BUF_32: BUF
    PORT MAP (Q => s_23, A => Qc2_Q);
BUF_33: BUF
    PORT MAP (Q => s_24, A => SRn);
TRI_47: TRI
    PORT MAP (Q => Qc1, A => Qc1_Q, EN => vcc);
DFFEARS_45: DFFEARS
    PORT MAP (Q => Qc1_Q, D => Qc1_REG, CLK => s_25, AR => gnd, AS => gnd, CE => vcc);
BUF_46: BUF
    PORT MAP (Q => s_25, A => CLKi);
XOR2_44: XOR2
    PORT MAP (Q => Qc1_REG, A1 => s_26, A2 => gnd);
OR1_43: OR1
    PORT MAP (Q => s_26, A1 => s_27);
AND2_42: AND2
    PORT MAP (Q => s_27, A1 => s_28, A2 => s_29);
BUF_40: BUF
    PORT MAP (Q => s_28, A => Qc0_Q);
BUF_41: BUF
    PORT MAP (Q => s_29, A => SRn);
TRI_54: TRI
    PORT MAP (Q => s_30, A => s_31, EN => vcc);
BUF_53: BUF
    PORT MAP (Q => s_31, A => s_32);
XOR2_52: XOR2
    PORT MAP (Q => s_32, A1 => s_33, A2 => gnd);
OR1_51: OR1
    PORT MAP (Q => s_33, A1 => s_34);
AND2_50: AND2
    PORT MAP (Q => s_34, A1 => s_35, A2 => s_36);
INV_48: INV
    PORT MAP (QN => s_35, A => Qc1_Q);
INV_49: INV
    PORT MAP (QN => s_36, A => Qc2_Q);
TRI_62: TRI
    PORT MAP (Q => Qc0, A => Qc0_Q, EN => vcc);
DFFEARS_60: DFFEARS
    PORT MAP (Q => Qc0_Q, D => Qc0_REG, CLK => s_37, AR => gnd, AS => gnd, CE => vcc);
BUF_61: BUF
    PORT MAP (Q => s_37, A => CLKi);
XOR2_59: XOR2
    PORT MAP (Q => Qc0_REG, A1 => s_38, A2 => gnd);
OR1_58: OR1
    PORT MAP (Q => s_38, A1 => s_39);
AND2_57: AND2
    PORT MAP (Q => s_39, A1 => s_40, A2 => s_41);
BUF_55: BUF
    PORT MAP (Q => s_40, A => s_30);
BUF_56: BUF
    PORT MAP (Q => s_41, A => SRn);
TRI_69: TRI
    PORT MAP (Q => RASe1, A => RASe1_Q, EN => vcc);
DFFEARS_67: DFFEARS
    PORT MAP (Q => RASe1_Q, D => RASe1_REG, CLK => s_42, AR => gnd, AS => gnd, CE => vcc);
BUF_68: BUF
    PORT MAP (Q => s_42, A => CLKi);
XOR2_66: XOR2
    PORT MAP (Q => RASe1_REG, A1 => s_43, A2 => gnd);
OR1_65: OR1
    PORT MAP (Q => s_43, A1 => s_44);
AND1_64: AND1
    PORT MAP (Q => s_44, A1 => s_45);
BUF_63: BUF
    PORT MAP (Q => s_45, A => RASe0_Q);
TRI_76: TRI
    PORT MAP (Q => RASe0, A => RASe0_Q, EN => vcc);
DFFEARS_74: DFFEARS
    PORT MAP (Q => RASe0_Q, D => RASe0_REG, CLK => s_46, AR => gnd, AS => gnd, CE => vcc);
BUF_75: BUF
    PORT MAP (Q => s_46, A => CLKi);
XOR2_73: XOR2
    PORT MAP (Q => RASe0_REG, A1 => s_47, A2 => gnd);
OR1_72: OR1
    PORT MAP (Q => s_47, A1 => s_48);
AND1_71: AND1
    PORT MAP (Q => s_48, A1 => s_49);
BUF_70: BUF
    PORT MAP (Q => s_49, A => RASei);
TRI_86: TRI
    PORT MAP (Q => RAS_, A => s_50, EN => vcc);
BUF_85: BUF
    PORT MAP (Q => s_50, A => s_51);
XOR2_84: XOR2
    PORT MAP (Q => s_51, A1 => s_52, A2 => gnd);
OR2_77: OR2
    PORT MAP (Q => s_52, A1 => s_53, A2 => s_54);
AND2_78: AND2
    PORT MAP (Q => s_53, A1 => s_55, A2 => s_56);
AND2_81: AND2
    PORT MAP (Q => s_54, A1 => s_57, A2 => s_58);
INV_79: INV
    PORT MAP (QN => s_55, A => RASe0_Q);
INV_80: INV
    PORT MAP (QN => s_56, A => RASe1_Q);
BUF_82: BUF
    PORT MAP (Q => s_57, A => RASe0_Q);
BUF_83: BUF
    PORT MAP (Q => s_58, A => RASe1_Q);

END P1508C84;
